<!-- schedule -->
<div class="modal fade" id="schedule">
  <div class="modal-dialog">
    <div class="modal-content" style="border-radius: 20px; box-shadow: 0 0 5px white; border: 3px ridge maroon">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
        <h4 class="modal-title"><b>Schedule Voting Time</b></h4>
      </div>

      <div class="modal-body">
        <div class="text-center">

          <!-- Loader (Hidden by Default) -->
          <div id="loader" style="display:none; color: maroon;">
            <b>scheduling Voting Time... <img src="https://icons8.com/preloaders/preloaders/830/Drop%20in%20a%20ring.gif" alt="Loading..." style="height: 50px; width: 50px; margin: 0 5px 7px 0;"> 
            Sending Voters Email... </b>
          </div>

          <!-- Form for scheduling -->
          <form id="scheduleForm" class="form-horizontal" method="POST">
            <div class="form-group">
              <label for="start_schedule" class="col-sm-3 control-label">Valid From: </label>
              <div class="col-sm-9">
                <input type="datetime-local" class="form-control" name="start_date">
              </div>
            </div>

            <div class="form-group">
              <label for="end_schedule" class="col-sm-3 control-label">Valid To: </label>
              <div class="col-sm-9">
                <input type="datetime-local" class="form-control" name="end_date">
              </div>
            </div>

            <!-- Messages placeholder -->
            <div id="message" style="margin-top: 10px;"></div>

            <div class="modal-footer">
              <button type="button" class="btn btn-default btn-flat pull-left" data-dismiss="modal"><i class="fa fa-close"></i> Close</button>
              <button type="submit" class="btn btn-primary btn-flat"><i class="fa fa-save"></i> Set</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</div>

<!-- Include jQuery for AJAX (if not already included) -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>
  $(document).ready(function() {
    // On form submission
    $('#scheduleForm').on('submit', function(e) {
      e.preventDefault(); // Prevent the default form submission
      $('#loader').show(); // Show loader

      // AJAX request to submit the form data without refreshing the page
      $.ajax({
        type: "POST",
        url: "schedule_save.php",
        data: $(this).serialize(), // Serialize the form data
        success: function(response) {
          $('#loader').hide(); // Hide loader
          $('#message').html(response); // Display success/error message
        },
        error: function() {
          $('#loader').hide(); // Hide loader if there's an error
          $('#message').html('<div class="alert alert-danger">An error occurred. Please try again later.</div>');
        }
      });
    });
  });
</script>