<?php
include 'includes/session.php';

ob_start(); // Start output buffering

// Function to generate the voting results table 
function generateRow($conn)
{
    $contents = '';
    // Fetch all positions ordered by priority
    $sql = "SELECT * FROM positions ORDER BY priority ASC";
    $query = $conn->query($sql);
    while ($row = $query->fetch_assoc()) {
        $id = $row['id'];
        // Add position description as a header
        $contents .= '
            <tr><td colspan="2"> </td> </tr>
            <tr>
                <td colspan="2" align="center" style="font-size:15px; color: maroon; padding-top: 15px; background-color: #fcdbdb"><b>' . $row['description'] . '</b></td>
            </tr>
            <tr style="font-size: 12px; padding: 4px; background-color: #fcbebe">
                <td width="80%"><b>Candidates</b></td>
                <td width="20%"><b>Votes</b></td>
            </tr>
        ';

        // Fetch candidates for each position and their vote counts in descending order
        $sql = "
            SELECT candidates.*, COUNT(votes.id) AS vote_count 
            FROM candidates 
            LEFT JOIN votes ON candidates.id = votes.candidate_id 
            WHERE candidates.position_id = '$id' 
            GROUP BY candidates.id 
            ORDER BY vote_count DESC
        ";
        $cquery = $conn->query($sql);
        while ($crow = $cquery->fetch_assoc()) {
            // Get the number of votes from the aggregated result
            $votes = $crow['vote_count'];

            // Add candidates and their votes to the table
            $contents .= '
                <tr>
                    <td>' . $crow['firstname'] . ' ' . $crow['lastname'] . '</td>
                    <td>' . $votes . '</td>
                </tr>
            ';
        }
    }

    return $contents;
}




// Load voting title from configuration
$parse = parse_ini_file('config.ini', FALSE, INI_SCANNER_RAW);
$title = $parse['election_title'];
$admin_name = 'LUBANGAKENE Cyrus'; // Replace with actual admin name

// Create PDF using TCPDF
require_once('../tcpdf/tcpdf.php');
$pdf = new TCPDF('P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetTitle('KAYE Voting Result: ' . $title);
$pdf->setHeaderFont(array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
$pdf->SetDefaultMonospacedFont('helvetica');
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
$pdf->SetMargins(PDF_MARGIN_LEFT, '10', PDF_MARGIN_RIGHT);
$pdf->setPrintHeader(false);
$pdf->setPrintFooter(TRUE);
$pdf->SetAutoPageBreak(TRUE, 10);
$pdf->SetFont('helvetica', '', 11);
$pdf->AddPage();

// Generate content for the PDF
$content = '';
$content .= '
		<div style="width: 90%; margin: auto; text-align: center;"> 
        <img src="../images/favicon.jpg" style="border-radius: 50%; height: 70px; width: 70px; padding: 1px;"> <br>
  		<span style="color: maroon; font-size: 16px; margin-bottom: 4px;"><b>AFRICA RENEWAL UNIVERSITY</b></span> <br>
  		<span style="color: maroon; font-size: 14px; margin-bottom: 4px;"><b>KAYE ONLINE VOTING</b> - TALLY RESULTS</span> <br>
  		<hr style=" height: 2px; color: maroon;">

		</div>

      	<h2 align="center">' . $title . '</h2>
      	<table border="1" cellspacing="0" cellpadding="3">  
      ';
$content .= '
    <table border="1" cellspacing="0" cellpadding="3">
        ' . generateRow($conn) . '
    </table>
';
$content .= '<br>';
$content .= '<br>';
$content .= '<br>';


// Output the PDF content
$pdf->writeHTML($content);

// Add footer with extraction time
// Get Admin Name
$admin_query = $conn->query("SELECT firstname, lastname FROM admin");
$admin_name = $admin_query->fetch_assoc();
$admin = $admin_name['firstname'] . ' ' . $admin_name['lastname'];

// set the time time zone to kampala (East Africa Time Zone);
date_default_timezone_set('Africa/Kampala');
$date = date('l, F j, Y g:i A');

$footer = '
    <div style="text-align: center;">
        <hr>
        <span style="font-size: 10px;">
            Extracted on: ' . $date . ' | Voting conducted by ' . $admin . '.
        </span>
    </div>
';
$pdf->writeHTMLCell(0, 0, '', '', $footer, 0, 1, 0, true, 'C', true);

// Close and output PDF
$pdf->Output('Election_Results - KAYE Online Voting.pdf', 'I');
