<?php
include 'includes/session.php';

ob_start(); // Start output buffering


// Function to generate table of registered voters, voters who voted, and voters who didn't vote
function generateVoterTables($conn)
{
    $contents = '';

    // Fetch all registered voters
    $sql_registered = "SELECT * FROM voters";
    $registered_query = $conn->query($sql_registered);

    // Table for total registered voters
    $contents .= '
        <table border="1" cellspacing="0" cellpadding="5px">
            <tr>
                <td colspan="4" align="center" width="106%" style="font-size:15px; color: maroon; padding-top: 15px; background-color: #fcdbdb"><b>Registered Voters</b></td>
            </tr>
            <tr style="font-size: 12px; padding: 4px; background-color: #fcbebe; font-weight: bold; text-align: center;">
                <th width="7%" padding="0" font-size="9px">No</th>
                <th width="20%">Registration Number</th>
                <th width="36%">Full Name</th>
                <th width="43%">Email</th>
            </tr>
    ';

    $i = 1; // Counter for row numbers
    while ($registered_row = $registered_query->fetch_assoc()) {
        $contents .= '
            <tr >
                <td style="padding: 0; font-size: 8px;">' . $i++ . '</td>
                <td style="padding: 2px;">' . $registered_row['voters_reg_no'] . '</td>
                <td style="padding: 2px;">' . $registered_row['firstname'] . ' ' . $registered_row['lastname'] . '</td>
                <td style="padding: 2px;">' . $registered_row['email'] . '</td>
            </tr>
        ';
    }
    $contents .= '</table><br>';

    // Fetch voters who participated (voted)
    $sql_voted = "SELECT voters.id, voters.voters_reg_no, voters.firstname, voters.lastname, voters.email 
              FROM voters 
              WHERE EXISTS (SELECT 1 FROM votes WHERE votes.voters_reg_no = voters.id)";
    $voted_query = $conn->query($sql_voted);

    // Page break before 'voted' table
    $contents .= '<pagebreak />';
    $contents .= '<br>';
    $contents .= '
        <h3>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>></h3>
    <table border="1" cellspacing="0" cellpadding="3">
        <tr>
            <td colspan="4" align="center" width="106%" style="font-size:15px; color: maroon; background-color: #fcdbdb"><b>Registered Voters Who Voted</b></td>
        </tr>
        <tr style="font-size: 12px; padding: 4px; background-color: #fcbebe; font-weight: bold; text-align: center;">
            <th width="7%" font-size="9px">No</th>
            <th width="20%">Registration Number</th>
            <th width="36%">Full Name</th>
            <th width="43%">Email</th>
        </tr>
';

    $j = 1; // Counter for row numbers
    while ($voted_row = $voted_query->fetch_assoc()) {
        $contents .= '
        <tr>
            <td style="padding: 0; font-size: 8px;">' . $j++ . '</td>
            <td>' . $voted_row['voters_reg_no'] . '</td>
            <td>' . $voted_row['firstname'] . ' ' . $voted_row['lastname'] . '</td>
            <td>' . $voted_row['email'] . '</td>
        </tr>
    ';
    }
    $contents .= '</table><br>';

    // Fetch voters who didn't participate (did not vote)
    $sql_did_not_vote = "SELECT voters.id, voters.voters_reg_no, voters.firstname, voters.lastname, voters.email 
                     FROM voters 
                     WHERE NOT EXISTS (SELECT 1 FROM votes WHERE votes.voters_reg_no = voters.id)";
    $did_not_vote_query = $conn->query($sql_did_not_vote);

    // Page break before 'did not vote' table
    $contents .= '<pagebreak />';
    $contents .= '
        <h3>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>></h3>
    <table border="1" cellspacing="0" cellpadding="3">
        <tr>
            <td colspan="4" align="center" width="106%" style="font-size:15px; color: maroon; background-color: #fcdbdb"><b>Registered Voters Who Did Not Participate</b></td>
        </tr>
        <tr style="font-size: 12px; padding: 4px; background-color: #fcbebe; font-weight: bold; text-align: center;">
            <th width="7%" font-size="9px">No</th>
            <th width="20%">Registration Number</th>
            <th width="36%">Full Name</th>
            <th width="43%">Email</th>
        </tr>
';

    $y = 1; // Counter for row numbers
    while ($did_not_vote_row = $did_not_vote_query->fetch_assoc()) {
        $contents .= '
        <tr>
            <td style="padding: 0; font-size: 8px;">' . $y++ . '</td>
            <td>' . $did_not_vote_row['voters_reg_no'] . '</td>
            <td>' . $did_not_vote_row['firstname'] . ' ' . $did_not_vote_row['lastname'] . '</td>
            <td>' . $did_not_vote_row['email'] . '</td>
        </tr>
    ';
    }
    $contents .= '</table><br>';


    return $contents;
}

// Load voting title from configuration
$parse = parse_ini_file('config.ini', FALSE, INI_SCANNER_RAW);
$title = $parse['election_title'];

// Create PDF using TCPDF
require_once('../tcpdf/tcpdf.php');
$pdf = new TCPDF('P', PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetTitle('KAYE Voters Report: ' . $title);
$pdf->setHeaderFont(array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
$pdf->SetDefaultMonospacedFont('helvetica');
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
$pdf->SetMargins(PDF_MARGIN_LEFT, '10', PDF_MARGIN_RIGHT);
$pdf->setPrintHeader(false);
$pdf->setPrintFooter(TRUE);
$pdf->SetAutoPageBreak(TRUE, 10);
$pdf->SetFont('helvetica', '', 11);
$pdf->AddPage();

// Generate content for the PDF
$content = '';
$content .= '
		<div style="width: 90%; margin: auto; text-align: center;"> 
        <img src="../images/favicon.jpg" style="border-radius: 50%; height: 70px; width: 70px; padding: 1px;"> <br>
  		<span style="color: maroon; font-size: 16px; margin-bottom: 4px;"><b>AFRICA RENEWAL UNIVERSITY</b></span> <br>
  		<span style="color: maroon; font-size: 14px; margin-bottom: 4px;"><b>KAYE ONLINE VOTING</b> - ELECTION RESULTS</span> <br>
  		<hr style=" height: 2px; color: maroon;">

		</div>

      	<h2 align="center">' . $title . ' - VOTERS REPORT</h2>
      	<table border="1" cellspacing="0" cellpadding="3">  
      ';


// Add voter tables
$content .= generateVoterTables($conn);

// Output the PDF content
$pdf->writeHTML($content);

// Add footer with extraction time
// Get Admin Name
$admin_query = $conn->query("SELECT firstname, lastname FROM admin");
$admin_name = $admin_query->fetch_assoc();
$admin = $admin_name['firstname'] . ' ' . $admin_name['lastname'];

// set the time time zone to kampala (East Africa Time Zone);
date_default_timezone_set('Africa/Kampala');
$date = date('l, F j, Y g:i A');

$footer = '
    <div style="text-align: center;">
        <hr>
        <span style="font-size: 10px;">
            Extracted on: ' . $date . ' | Voting conducted by ' . $admin . '.
        </span>
    </div>
';
$pdf->writeHTMLCell(0, 0, '', '', $footer, 0, 1, 0, true, true);

// Close and output PDF
$pdf->Output('Voters PDF Report - KAYE Online Voting.pdf', 'I');
