<?php
include 'includes/session.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require 'includes/PHPMailer/src/Exception.php';
require 'includes/PHPMailer/src/PHPMailer.php';
require 'includes/PHPMailer/src/SMTP.php';

if (isset($_POST['start_date']) && isset($_POST['end_date'])) {
    $start_date = $_POST['start_date'];
    $end_date = $_POST['end_date'];

    // Update schedule in the database
    $sql = "UPDATE schedule SET start_date = '$start_date', end_date = '$end_date' WHERE id = 1";
    if ($conn->query($sql)) {
        // Fetch updated schedule for email notification
        $sql_schedule = "SELECT start_date, end_date FROM schedule WHERE id = 1";
        $schedule_query = $conn->query($sql_schedule);
        $schedule_row = $schedule_query->fetch_assoc();
        $start_date_formatted = date('F j, Y, g:i a', strtotime($schedule_row['start_date']));
        $end_date_formatted = date('F j, Y, g:i a', strtotime($schedule_row['end_date']));

        // Fetch all registered voters
        $sql_voters = "SELECT firstname, lastname, email FROM voters";
        $voters_query = $conn->query($sql_voters);

        // Email setup using PHPMailer
        $mail = new PHPMailer(true);
        try {
            $mail->isSMTP();
            $mail->Host = 'smtp.gmail.com';
            $mail->SMTPAuth = true;
            $mail->Username = 'ocyrusbrianlub015@gmail.com'; // Your email
            $mail->Password = 'scktnnvzvcelynwn'; // Your app-specific password
            $mail->SMTPSecure = 'tls';
            $mail->Port = 587;

            $mail->SMTPKeepAlive = true;  // Enable keep-alive to avoid reconnecting to SMTP

            $mail->setFrom('ocyrusbrianlub015@gmail.com', 'Africa Renewal University');
            $mail->isHTML(true);
            $mail->Subject = 'REMINDER: Scheduled Online Voting Times';

            $parse = parse_ini_file('config.ini', FALSE, INI_SCANNER_RAW);
            $title = $parse['election_title'];

            // Prepare the base body of the email
            $mail_body = "
                <html>
                <head>
                    <style>
                        table {width: 100%; border-collapse: collapse;}
                        th, td {border: 1px solid #ddd; padding: 8px; font-weight: bolder;}
                        th {background-color: #fcdbdb; color: maroon; font-size: 15px;}
                        tr:nth-child(even) {background-color: #fcb3b3;}
                        tr:hover {background-color: #fcdbdb;}
                    </style>
                </head>

                <body>
                    <div style='width: 90%; margin: auto; text-align: center;'> 
                        <img src='https://afru.ac.ug/wp-content/uploads/2024/04/cropped-logo-png.png' style='border-radius: 50%; height: 70px; width: 70px; padding: 1px;' alt='AFRU'> <br> 
                        <span style='color: maroon; font-size: 16px; margin-bottom: 4px;'><b>AFRICA RENEWAL UNIVERSITY</b></span> <br>
                        <span style='color: maroon; font-size: 14px; margin-bottom: 4px;'><b>KAYE ONLINE VOTING</b></span> <br>
                        <h3 align='center'>Election Registration Confirmation & Voting Time Scheduled</h3>
                        <hr style='height: 2px; color: #800000;'/>
                    </div>
                    <p>Dear <b>Voter,</b></p>
                    <p>We are pleased to inform you that you have been successfully registered to participate in the upcoming election for <b>Africa Renewal University - $title</b>.</p>
                    
                    <p><b>IMPORTANT:</b> For your security, we highly recommend that you change your login password from the default <b>'123'</b> to a password of your choice.</p>
                    <p>This will help prevent anyone from accessing your account and voting on your behalf.</p>
                    
                    <p>We encourage you to participate in this election and make your voice heard in shaping the future of our university. <b>Your vote matters!</b></p>

                    <h2>Voting Schedule</h2>
                    <table>
                        <thead>
                            <tr>
                                <th>Event</th>
                                <th>Date and Time</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>Voting Starting Time</td>
                                <td>$start_date_formatted</td>
                            </tr>
                            <tr>
                                <td>Voting Ending Time</td>
                                <td>$end_date_formatted</td>
                            </tr>
                        </tbody>
                    </table>

                    <p>Thank you for being an important part of this democratic process. Together, we can make a difference!</p>
                    <hr/>

                    <p><b>To change your password: Click <a href='http://127.0.0.1/my_projects/Kayer_Voting_System/forgot-password.php' target='_blank'>here</a></b> or;
                        <dl>
                            <dt>1. Please <a href='http://127.0.0.1/my_projects/Kayer_Voting_System/index.php' target='_blank'>log in to your account</a> on the voting page</dt>
                            <dd>- Enter your Student registration number</dd>
                            <dd>- Enter the default password <b>123</b></dd>
                            <dt>2. Edit your Profile</dt>
                            <dd>- On the top right corner, click UPDATE</dd>
                            <dd>- Change your user profile information correctly</dd>
                        </dl>
                    </p>

                    <p><b>Best regards,<br>
                    The Online Election Team <br>
                    Africa Renewal University</b></p>
                </body>
                </html>
            ";

            $batchSize = 10;  // Number of emails to send per batch
            $delayBetweenBatches = 5;  // Delay in seconds between batches
            
            $failedEmails = [];
            $successfulEmails = 0;

            // Prepare voters data
            $voters = [];
            while ($voter_row = $voters_query->fetch_assoc()) {
                $voters[] = $voter_row;
            }

            $totalVoters = count($voters);
            $totalBatches = ceil($totalVoters / $batchSize);

            // Batch processing
            for ($batch = 0; $batch < $totalBatches; $batch++) {
                $batchStart = $batch * $batchSize;
                $batchEnd = min($batchStart + $batchSize, $totalVoters);

                for ($i = $batchStart; $i < $batchEnd; $i++) {
                    $voter = $voters[$i];
                    $voter_email = $voter['email'];
                    $voter_fullname = $voter['firstname'] . ' ' . $voter['lastname'];

                    if (filter_var($voter_email, FILTER_VALIDATE_EMAIL)) {
                        $personalized_body = str_replace("Voter,", "$voter_fullname,", $mail_body);
                        $mail->addAddress($voter_email, $voter_fullname);
                        $mail->Body = $personalized_body;

                        if (!$mail->send()) {
                            $failedEmails[] = $voter_email;
                        } else {
                            $successfulEmails++;
                        }
                        $mail->clearAddresses();
                    } else {
                        $failedEmails[] = $voter_email;
                    }
                }

                // Sleep between batches
                if ($batch < $totalBatches - 1) {
                    sleep($delayBetweenBatches);
                }
            }

            if (count($failedEmails) > 0) {
                echo '<div class="alert alert-error">Failed to send to: ' . implode(', ', $failedEmails) . '</div>';
            }
            if ($successfulEmails > 0) {
                echo '<div class="alert alert-success">Emails sent successfully to ' . $successfulEmails . ' voters.</div>';
            }
        } catch (Exception $e) {
            echo '<div class="alert alert-danger">Mailer Error: ' . $mail->ErrorInfo . '</div>';
        }
    } else {
        echo '<div class="alert alert-danger">Failed to update schedule: ' . $conn->error . '</div>';
    }
} else {
    echo '<div class="alert alert-danger">Please fill in all fields before submitting.</div>';
}
