<?php include 'includes/session.php'; ?>
<?php include 'includes/slugify.php'; ?>
<?php include 'includes/header.php'; ?>

<body class="hold-transition skin-blue sidebar-mini">
    <div class="wrapper">

        <?php include 'includes/navbar.php'; ?>
        <?php include 'includes/menubar.php'; ?>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <h1>
                    <b>VOTING RESULTS</b>
                </h1>
                <ol class="breadcrumb">
                    <li><a href="home.php"><i class="fa fa-dashboard"></i> Home</a></li>
                    <li class="active">results</li>
                </ol>
            </section>

            <!-- Main content -->
            <section class="content">

                <div class="row">
                    <div class="col-xs-12">
                        <h3>'

                            <div class="dropdown show pull-left">

                                <button class="btn btn-success btn-sm btn-flat dropdown-toggle" type="button" data-toggle="dropdown">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Display Format &nbsp;
                                    <span class="caret"></span>
                                </button>

                                <ul class="dropdown-menu">
                                    <li class="dropdown-header"> <kbd> <b>Display Result as barGraph</b> </kbd></li>
                                    <li><a href="tally.php"> <span class="glyphicon glyphicon-download"></span> Horizontal Graph</a></li>
                                    <li><a href="tally_vertical_graph.php"> <span class="glyphicon glyphicon-download"></span> Vertical Graph</a></li>

                                    <li class="divider"></li>
                                    <li class="dropdown-header"> <kbd> <b>Display Result as PieChart</b> </kbd></li>
                                    <li><a href="tally_piechart.php"> <span class="glyphicon glyphicon-download"></span> Pie Chart</a></li>

                                </ul>
                            </div>


                            <div class="dropdown show pull-right">

                                <button class="btn btn-success btn-sm btn-flat hidden-xs" id="print_page">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Print Page &nbsp;
                                </button>

                                <button class="btn btn-success btn-sm btn-flat dropdown-toggle" type="button" data-toggle="dropdown">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Print Reports &nbsp;
                                    <span class="caret"></span>
                                </button>

                                <ul class="dropdown-menu">
                                    <li class="dropdown-header"> <kbd> <b>Print out PDF Reports</b> </kbd></li>
                                    <li><a href="print_tally.php"> <span class="glyphicon glyphicon-download"></span> Tally Results</a></li>
                                    <li><a href="print_voters_pdf.php"> <span class="glyphicon glyphicon-download"></span> Voters Summary</a></li>
                                    <li><a href="print_election_summary_pdf.php"> <span class="glyphicon glyphicon-download"></span> Election Summary</a></li>

                                    <li class="divider"></li>
                                    <li class="dropdown-header"> <kbd> <b>Print out CSV Reports</b> </kbd></li>
                                    <li><a href="print_voters_csv.php"> <span class="glyphicon glyphicon-download"></span> Voters data</a></li>
                                </ul>
                            </div>

                            <!-- </span> -->
                        </h3>
                    </div>
                </div>

                <?php
                $sql = "SELECT * FROM positions ORDER BY priority ASC";
                $query = $conn->query($sql);
                $inc = 2;
                while ($row = $query->fetch_assoc()) {
                    $inc = ($inc == 2) ? 1 : $inc + 1;
                    if ($inc == 1) echo "<div class='row'>";
                    echo "
            <div class='col-sm-6'>
              <div class='box box-solid' style='box-shadow: 0 0 4px black; border-radius: 4%'>  <!----------styling the box for tallies----------->
                <div class='box-header with-border'>
                  <h4 class='box-title'><b>" . $row['description'] . "</b></h4>
                </div>
                <div class='box-body'>
                  <div class='chart'>
                    <canvas id='" . slugify($row['description']) . "' style='height:200px'></canvas>
                  </div>
                </div>
              </div>
            </div>
          ";
                    if ($inc == 2) echo "</div>";
                }
                if ($inc == 1) echo "<div class='col-sm-6'></div></div>";
                ?>

            </section>
            <!-- right col -->
        </div>


        <?php include 'includes/footer.php'; ?>

    </div>
    <!-- ./wrapper -->

    <?php include 'includes/scripts.php'; ?>

    <!-- Script for Pie Charts -->
    <?php
    $sql = "SELECT * FROM positions ORDER BY priority ASC";
    $query = $conn->query($sql);

    while ($row = $query->fetch_assoc()) {
        // Fetch candidates for each position
        $sql = "SELECT * FROM candidates WHERE position_id = '" . $row['id'] . "'";
        $cquery = $conn->query($sql);
        $carray = array(); // Array to hold candidates
        $varray = array(); // Array to hold votes

        while ($crow = $cquery->fetch_assoc()) {
            array_push($carray, $crow['lastname']); // Add candidate name to array
            $sql = "SELECT * FROM votes WHERE candidate_id = '" . $crow['id'] . "'";
            $vquery = $conn->query($sql);
            array_push($varray, $vquery->num_rows); // Add number of votes to array
        }

        $carray = json_encode($carray); // Convert to JSON for JavaScript use
        $varray = json_encode($varray);
    ?>

        <script>
            $(function() {
                // Reduce the chart size by adjusting the canvas dimensions
                var ctx = $('#<?php echo slugify($row['description']); ?>').get(0).getContext('2d');

                // Define the pie chart
                var pieChart = new Chart(ctx, {
                    type: 'pie',
                    data: {
                        labels: <?php echo $carray; ?>, // Candidate names
                        datasets: [{
                            label: 'Votes',
                            data: <?php echo $varray; ?>, // Votes count
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.7)',
                                'rgba(54, 162, 235, 0.7)',
                                'rgba(255, 206, 86, 0.7)',
                                'rgba(75, 192, 192, 0.7)',
                                'rgba(153, 102, 255, 0.7)'
                            ]
                        }]
                    },
                    options: {
                        responsive: true,
                        maintainAspectRatio: false, // Prevent Chart.js from maintaining the aspect ratio
                        plugins: {
                            legend: {
                                position: 'top',
                            },
                            // Add the ChartDataLabels plugin to display the name and votes
                            datalabels: {
                                color: '#000', // Font color
                                font: {
                                    weight: 'bold',
                                    size: 12 // Adjust font size
                                },
                                formatter: function(value, context) {
                                    var label = context.chart.data.labels[context.dataIndex];
                                    return label + ': ' + value; // Show candidate name and votes
                                }
                            }
                        },
                        animation: {
                            animateScale: true,
                            animateRotate: true
                        }
                    },
                    plugins: [ChartDataLabels] // Enable the ChartDataLabels plugin
                });
            });
        </script>

        <script src="https://cdn.jsdelivr.net/npm/chart.js@3.7.1/dist/chart.min.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/chartjs-plugin-datalabels@2.0.0"></script>


        <script src="https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.9.2/html2pdf.bundle.min.js"></script>
        <script>
            document.getElementById("print_page").addEventListener("click", function() {
                // Target the specific section to print
                var element = document.querySelector("section.content");

                // Options for the pdf generation
                var opt = {
                    margin: 0,
                    filename: 'PieChart Results Page - KAYE Voting System.pdf',
                    image: {
                        type: 'png',
                        quality: 0.5
                    },
                    html2canvas: {
                        scale: 1
                    },
                    jsPDF: {
                        unit: 'in',
                        format: 'letter',
                        orientation: 'portrait'
                    }
                };

                // Create and save the PDF
                html2pdf().set(opt).from(element).save();
            });
        </script>

    <?php
    }
    ?>

</body>

</html>