<?php include 'includes/session.php'; ?>
<?php include 'includes/slugify.php'; ?>
<?php include 'includes/header.php'; ?>

<body class="hold-transition skin-blue sidebar-mini">
    <div class="wrapper">

        <?php include 'includes/navbar.php'; ?>
        <?php include 'includes/menubar.php'; ?>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <h1>
                    <b>RESULTS</b>
                </h1>
                <ol class="breadcrumb">
                    <li><a href="home.php"><i class="fa fa-dashboard"></i> Home</a></li>
                    <li class="active">results</li>
                </ol>
            </section>

            <!-- Main content -->
            <section class="content">

                <div class="row">
                    <div class="col-xs-12">
                        <h3>'

                            <div class="dropdown show pull-left">

                                <button class="btn btn-success btn-sm btn-flat dropdown-toggle" type="button" data-toggle="dropdown">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Display Format &nbsp;
                                    <span class="caret"></span>
                                </button>

                                <ul class="dropdown-menu">
                                    <li class="dropdown-header"> <kbd> <b>Display Result as barGraph</b> </kbd></li>
                                    <li><a href="tally.php"> <span class="glyphicon glyphicon-download"></span> Horizontal Graph</a></li>
                                    <li><a href="tally_vertical_graph.php"> <span class="glyphicon glyphicon-download"></span> Vertical Graph</a></li>

                                    <li class="divider"></li>
                                    <li class="dropdown-header"> <kbd> <b>Display Result as PieChart</b> </kbd></li>
                                    <li><a href="tally_piechart.php"> <span class="glyphicon glyphicon-download"></span> Pie Chart</a></li>

                                </ul>
                            </div>


                            <div class="dropdown show pull-right">

                                <button class="btn btn-success btn-sm btn-flat hidden-xs" id="print_page">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Print Page &nbsp;
                                </button>

                                <button class="btn btn-success btn-sm btn-flat dropdown-toggle" type="button" data-toggle="dropdown">
                                    <span class="glyphicon glyphicon-print"></span> &nbsp; Print Reports &nbsp;
                                    <span class="caret"></span>
                                </button>

                                <ul class="dropdown-menu">
                                    <li class="dropdown-header"><kbd><b>Print out PDF Reports</b></kbd></li>
                                    <li><a href="print_tally.php"><span class="glyphicon glyphicon-download"></span> Tally Results</a></li>
                                    <li><a href="print_voters_pdf.php"><span class="glyphicon glyphicon-download"></span> Voters Summary</a></li>
                                    <li><a href="print_election_summary_pdf.php"><span class="glyphicon glyphicon-download"></span> Election Summary</a></li>

                                    <li class="divider"></li>
                                    <li class="dropdown-header"><kbd><b>Print out CSV Reports</b></kbd></li>
                                    <li><a href="print_voters_csv.php"><span class="glyphicon glyphicon-download"></span> Voters data</a></li>
                                </ul>
                            </div>
                        </h3>
                    </div>
                </div>

                <?php
                // Fetch positions from the database
                $sql = "SELECT * FROM positions ORDER BY priority ASC";
                $query = $conn->query($sql);
                $inc = 2; // Variable to manage column layout

                // Loop through each position to display results
                while ($row = $query->fetch_assoc()) {
                    $inc = ($inc == 2) ? 1 : $inc + 1; // Alternate between two columns
                    if ($inc == 1) echo "<div class='row'>"; // Start a new row if needed

                    // Display each position's tally box
                    echo "
                        <div class='col-sm-6'>
                            <div class='box box-solid' style='box-shadow: 0 0 4px black; border-radius: 4%'>  
                                <div class='box-header with-border'>
                                    <h4 class='box-title'><b>" . $row['description'] . "</b></h4>
                                </div>
                                <div class='box-body'>
                                    <div class='chart'>
                                        <canvas id='" . slugify($row['description']) . "' style='height:200px'></canvas> <!-- Chart canvas for votes -->
                                    </div>
                                </div>
                            </div>
                        </div>
                    ";
                    if ($inc == 2) echo "</div>"; // Close the row after two columns
                }
                // Close any remaining open column
                if ($inc == 1) echo "<div class='col-sm-6'></div></div>";
                ?>

            </section>
            <!-- right col -->
        </div>

        <?php include 'includes/footer.php'; ?>

    </div>
    <!-- ./wrapper -->

    <?php include 'includes/scripts.php'; ?>

    <?php
    // Fetch positions again to get candidates and their votes
    $sql = "SELECT * FROM positions ORDER BY priority ASC";
    $query = $conn->query($sql);
    while ($row = $query->fetch_assoc()) {
        // Fetch candidates for the current position
        $sql = "SELECT * FROM candidates WHERE position_id = '" . $row['id'] . "'";
        $cquery = $conn->query($sql);
        $carray = array(); // Array for candidate names
        $varray = array(); // Array for vote counts

        // Loop through candidates to get their vote counts
        while ($crow = $cquery->fetch_assoc()) {
            array_push($carray, $crow['lastname']); // Store candidate names
            $sql = "SELECT * FROM votes WHERE candidate_id = '" . $crow['id'] . "'";
            $vquery = $conn->query($sql);
            array_push($varray, $vquery->num_rows); // Store vote counts
        }

        $carray = json_encode($carray); // Convert to JSON for use in JavaScript
        $varray = json_encode($varray); // Convert to JSON for use in JavaScript
    ?>

        <script>
            $(function() {
                var rowid = '<?php echo $row['id']; ?>';
                var description = '<?php echo slugify($row['description']); ?>';
                var barChartCanvas = $('#' + description).get(0).getContext('2d');

                var candidateLabels = <?php echo $carray; ?>; // Candidate names
                var voteCounts = <?php echo $varray; ?>; // Vote counts

                var barChartData = {
                    labels: candidateLabels,
                    datasets: [{
                        label: 'Votes',
                        backgroundColor: 'maroon', // Bar color
                        borderColor: '#240000', // Bar border color
                        data: voteCounts // Vote counts as data
                    }]
                };

                // Define chart options
                var barChartOptions = {
                    responsive: true,
                    maintainAspectRatio: true,
                    scales: {
                        yAxes: [{
                            ticks: {
                                beginAtZero: true, // Start y-axis at zero
                                stepSize: 1 // Ensure the step size is 1 to show small differences
                            }
                        }],
                        xAxes: [{
                            ticks: {
                                autoSkip: false // Prevent skipping of labels on x-axis
                            }
                        }]
                    },
                    // Add vote count labels on top of the bars
                    plugins: {
                        datalabels: {
                            anchor: 'end', // Position the labels at the top of the bar
                            align: 'end', // Align the labels properly with the bars
                            color: '#ffffff', // White color for better visibility
                            font: {
                                weight: 'bold'
                            },
                            formatter: function(value) {
                                return value; // Display the vote count as the label
                            }
                        }
                    }
                };

                // Create the bar chart
                var myBarChart = new Chart(barChartCanvas, {
                    type: 'bar', // Set the chart type to 'bar' (for vertical bar chart)
                    data: barChartData, // Use the prepared data
                    options: barChartOptions
                });
            });
        </script>

        <script src="https://cdn.jsdelivr.net/npm/chart.js@3.7.1/dist/chart.min.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/chartjs-plugin-datalabels@2.0.0"></script>

        <script src="https://cdnjs.cloudflare.com/ajax/libs/html2pdf.js/0.9.2/html2pdf.bundle.min.js"></script>
        <script>
            document.getElementById("print_page").addEventListener("click", function() {
                // Target the specific section to print
                var element = document.querySelector("section.content");

                // Options for the pdf generation
                var opt = {
                    margin: 0,
                    filename: 'BarGraph Results Page - KAYE Voting System.pdf',
                    image: {
                        type: 'png',
                        quality: 0.5
                    },
                    html2canvas: {
                        scale: 1
                    },
                    jsPDF: {
                        unit: 'in',
                        format: 'letter',
                        orientation: 'portrait'
                    }
                };

                // Create and save the PDF
                html2pdf().set(opt).from(element).save();
            });
        </script>


    <?php
    } // End of candidates loop
    ?>
</body>

</html>