 <?php
	/**
	 * Handles the addition of a new voter to the system.
	 *
	 * This function processes the form submission for adding a new voter. It first
	 * checks if the voter's registration number or email already exists in the
	 * database. If not, it inserts the new voter's information into the database.
	 * If the voter already exists, it sets an error session variable with the
	 * appropriate error message.
	 *
	 * After processing the form, it redirects the user to the voters.php page.
	 */

	include 'includes/session.php';

	if (isset($_POST['add'])) {
		$firstname = $_POST['firstname'];
		$lastname = $_POST['lastname'];
		$voters_reg_no = $_POST['voters_reg_no'];
		$email = $_POST['email'];
		$password = password_hash($_POST['password'], PASSWORD_DEFAULT);
		$filename = $_FILES['photo']['name'];
		if (!empty($filename)) {
			move_uploaded_file($_FILES['photo']['tmp_name'], '../images/' . $filename);
		}

		// Check if voter's registration number or email already exist
		$check_sql = "SELECT * FROM voters WHERE voters_reg_no = '$voters_reg_no' OR email = '$email'";
		$check_query = $conn->query($check_sql);

		if ($check_query->num_rows > 0) {
			// Voter already exists, check for specific field
			$existing_voter = $check_query->fetch_assoc();
			if ($existing_voter['voters_reg_no'] === $voters_reg_no) {
				$_SESSION['error'] = 'Voter with this registration number already exists.';
			} elseif ($existing_voter['email'] === $email) {
				$_SESSION['error'] = 'Voter with this email already exists.';
			}
		} else {
			// If no matching voter, proceed with insertion

			$sql = "INSERT INTO voters (voters_reg_no, password, firstname, lastname, email, photo) 
		VALUES ('$voters_reg_no', '$password', '$firstname', '$lastname', '$email', '$filename')";
			if ($conn->query($sql)) {
				$_SESSION['success'] = 'Voter added successfully';
			} else {
				$_SESSION['error'] = $conn->error;
			}
		}
	} else {
		$_SESSION['error'] = 'Fill up add form first';
	}

	header('location: voters.php');
	?>