<?php
	session_start();
	include 'includes/conn.php';

	date_default_timezone_set('Africa/Kampala'); // I Replaced 'Your/Timezone' with the appropriate timezone


	if(isset($_POST['login'])){
		$voters_reg_no = $_POST['voter'];
		$password = $_POST['password'];

		$sql = "SELECT * FROM voters WHERE voters_reg_no = '$voters_reg_no'";
		$query = $conn->query($sql);

		if($query->num_rows < 1){
			$_SESSION['error'] = 'Cannot find voter with this Registration Number';
		}
		else{
			$row = $query->fetch_assoc();

			// Check if the password matches
			if(password_verify($password, $row['password'])){

				// Get the voting start and end times from your schedule table
				$settings_sql = "SELECT start_date, end_date FROM schedule WHERE id = 1"; // Adjusted as needed
				$settings_query = $conn->query($settings_sql);
				$settings_row = $settings_query->fetch_assoc();

				// Ensured that voting schedule data is fetched correctly
				if ($settings_row) {
					$voting_start = $settings_row['start_date'];
					$voting_end = $settings_row['end_date'];

					// Get current time in the same format for proper comparison
					$current_time = date('Y-m-d H:i:s');

					// Debugging output to ensure correct values
					
					// Check if current time is before voting start time
					if($current_time < $voting_start){
						$_SESSION['error'] = '<b>Voting has not yet started.</b><br><b><i>Current Time:</i></b> '.$current_time. '<br><b><i>Voting Start: </b></i>'.$voting_start;
					}
					// Check if current time is after voting end time
					elseif($current_time >= $voting_end){
						$_SESSION['error'] = '<b>Voting has already ended.</b><br><b><i>Voting Ended: </i></b>' .$voting_end. '<br><b><i>Current Time: </i></b>' .$current_time;
					}
					else{
						// If all checks pass, log in the user
						$_SESSION['voter'] = $row['id'];
					}
				} else {
					$_SESSION['error'] = 'Voting schedule not found. Please contact the administrator.';
				}

			}
			else{
				$_SESSION['error'] = 'Incorrect Password Entered';
			}
		}
		
	}
	else{
		$_SESSION['error'] = 'Input voter credentials first';
	}

	header('location: index.php');
?>
