<?php
// include 'includes/session.php'; // Include your session or DB connection
include 'includes/conn.php';
include 'includes/header.php';

if (isset($_GET['token'])) {
    $token = $_GET['token'];

    // Validate token and check expiry
    $sql = "SELECT * FROM voters WHERE reset_token='$token' AND token_expiry > NOW()";
    $query = $conn->query($sql);

    if ($query->num_rows > 0) {
        $row = $query->fetch_assoc();

        // Handle form submission
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            // Retrieve the new password and confirm password from the form
            $new_password = $_POST['new_password'];
            $confirm_new_password = $_POST['confirm_new_password'];

            // Check if both passwords match
            if ($new_password === $confirm_new_password) {
                // If passwords match, hash the new password
                $hashed_password = password_hash($new_password, PASSWORD_DEFAULT);

                // Update the password in the database and clear the token and expiry
                $update_sql = "UPDATE voters SET password='$hashed_password', reset_token=NULL, token_expiry=NULL WHERE reset_token='$token'";

                if ($conn->query($update_sql)) {
                    // Success message
                    $_SESSION['success'] = "Password reset successfully! Close this tab and login.";
                } else {
                    // Error message for database update failure
                    $_SESSION['error'] = 'Error resetting password.';
                }
            } else {
                // Error message if passwords don't match
                $_SESSION['error'] = 'Passwords do not match. Please try again.';
            }
        }
    } else {
        // Error message for invalid or expired token
        $_SESSION['error'] = "Expired token. Please Resubmit your request.";
    }
} else {
    // Error message for missing token
    $_SESSION['error'] = "No token provided.";
}
?>

<body class="hold-transition login-page" style="background-color: maroon">
    <div class="login-box">
        <div class="login-logo">
            <a href=""><img src="images/afru logo.jpg" style="border-radius: 50%; height: 100px; width: 100px;"></a> <br>
            <h3 style="color: white"><b>KAYE Online Voting</b></h3>
        </div>

        <div class="login-box-body"
            style="
            border-top-left-radius: 20%;
            border-bottom-right-radius: 30%;
            box-shadow: 0 0 20px #fff;
         ">
            <h4 class="login-box-msg">Reset New User Password</h4>

            <?php
            // Display error message, if any
            if (isset($_SESSION['error'])) {
                echo "
                <div class='alert alert-danger alert-dismissible'>
				    <button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>
				    <h4><i class='icon fa fa-times'></i> Reset Password Error!</h4>
				    " . $_SESSION['error'] . "
				</div>                
  			";
                unset($_SESSION['error']);
            }

            // Display success message, if any
            if (isset($_SESSION['success'])) {
                echo "
				<div class='alert alert-success alert-dismissible'>
				    <button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>
				    <h4><i class='icon fa fa-check'></i> Reset Successful!</h4>
				    " . $_SESSION['success'] . "
				</div>
			";
                unset($_SESSION['success']);
            }
            ?>

            <!-- Password Reset Form -->
            <form action="" method="POST">
                <!-- New Password Field -->
                <div class="form-group has-feedback">
                    <input type="password" class="form-control" name="new_password" placeholder="Enter new password" required>
                    <span class="glyphicon glyphicon-lock form-control-feedback"></span>
                </div>

                <!-- Confirm New Password Field -->
                <div class="form-group has-feedback">
                    <input type="password" class="form-control" name="confirm_new_password" placeholder="Confirm new password" required>
                    <span class="glyphicon glyphicon-lock form-control-feedback"></span>
                </div>

                <!-- Submit Button -->
                <div class="row">
                    <div class="col-xs-4">
                        <button type="submit" class="btn btn-primary btn-block btn-flat" name="reset">
                            <i class="fa fa-sign-in"></i> Reset</button>
                    </div>
                    <div class="col-xs-4">
                        <button type="button" class="btn btn-success btn-block btn-flat" name="login">
                            <i class="fa fa-sign-in"></i> <a href="index.php" style="color: #fff;"> Login</a></button>
                    </div>
                </div>
            </form>
        </div>

    </div>

    <?php include 'includes/scripts.php' ?>
</body>

</html>